!!****m* ABINIT/interfaces_12_hide_mpi
!! NAME
!! interfaces_12_hide_mpi
!!
!! FUNCTION
!! This module contains the interfaces of the routines
!! in the directory src/12_hide_mpi
!!
!! COPYRIGHT
!! Copyright (C) 2009 ABINIT group
!! This file is distributed under the terms of the
!! GNU General Public License, see ~abinit/COPYING
!! or http://www.gnu.org/copyleft/gpl.txt .
!!
!! NOTES
!! THIS FILE IS GENERATED AUTOMATICALLY BY abilint.
!! To do that: config/scripts/abilint . .
!! 
!!
!! SOURCE

module interfaces_12_hide_mpi

 implicit none


!Generic interface of the routines xallgather_mpi
interface xallgather_mpi
 subroutine xallgather_mpi_int(xval,recvcounts,spaceComm,ier)
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: spaceComm
  integer,intent(inout) :: xval
  integer,intent(inout) :: recvcounts(:)
 end subroutine xallgather_mpi_int
 subroutine xallgather_mpi_dp1d(xval,nelem,recvcounts,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: nelem
  integer ,intent(in) :: spaceComm
  real(dp),intent(inout) :: recvcounts(:)
  real(dp),intent(in) :: xval(:)
 end subroutine xallgather_mpi_dp1d
 subroutine xallgather_mpi_dp4d(xval,nelem,recvcounts,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: nelem
  integer ,intent(in) :: spaceComm
  real(dp),intent(inout) :: recvcounts(:,:,:,:)
  real(dp),intent(in) :: xval(:,:,:,:)
 end subroutine xallgather_mpi_dp4d
end interface
!End of the generic interface of xallgather_mpi


!Generic interface of the routines xallgatherv_mpi
interface xallgatherv_mpi
 subroutine xallgatherv_mpi_int2d(xval,nelem,recvbuf,recvcounts,displs,spaceComm,ier)
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: nelem
  integer,intent(in) :: spaceComm
  integer,intent(in) :: displs(:)
  integer,intent(inout) :: recvbuf(:,:)
  integer,intent(in) :: recvcounts(:)
  integer,intent(in) :: xval(:,:)
 end subroutine xallgatherv_mpi_int2d
 subroutine xallgatherv_mpi_int(xval,nelem,recvbuf,recvcounts,displs,spaceComm,ier)
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: nelem
  integer,intent(in) :: spaceComm
  integer,intent(in) :: displs(:)
  integer,intent(inout) :: recvbuf(:)
  integer,intent(in) :: recvcounts(:)
  integer,intent(in) :: xval(:)
 end subroutine xallgatherv_mpi_int
 subroutine xallgatherv_mpi_dp(xval,nelem,recvbuf,recvcounts,displs,spaceComm,ier)
  use defs_basis
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: nelem
  integer,intent(in) :: spaceComm
  integer,intent(in) :: displs(:)
  integer,intent(in) :: recvcounts(:)
  real(dp),intent(inout) :: recvbuf(:)
  real(dp),intent(in) :: xval(:)
 end subroutine xallgatherv_mpi_dp
 subroutine xallgatherv_mpi_dp2d(xval,nelem,recvbuf,recvcounts,displs,spaceComm,ier)
  use defs_basis
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: nelem
  integer,intent(in) :: spaceComm
  integer,intent(in) :: displs(:)
  integer,intent(in) :: recvcounts(:)
  real(dp),intent(inout) :: recvbuf(:,:)
  real(dp),intent(in) :: xval(:,:)
 end subroutine xallgatherv_mpi_dp2d
 subroutine xallgatherv_mpi_dp3d(xval,nelem,recvbuf,recvcounts,displs,spaceComm,ier)
  use defs_basis
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: nelem
  integer,intent(in) :: spaceComm
  integer,intent(in) :: displs(:)
  integer,intent(in) :: recvcounts(:)
  real(dp),intent(inout) :: recvbuf(:,:,:)
  real(dp),intent(in) :: xval(:,:,:)
 end subroutine xallgatherv_mpi_dp3d
 subroutine xallgatherv_mpi_dp4d(xval,nelem,recvbuf,recvcounts,displs,spaceComm,ier)
  use defs_basis
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: nelem
  integer,intent(in) :: spaceComm
  integer,intent(in) :: displs(:)
  integer,intent(in) :: recvcounts(:)
  real(dp),intent(inout) :: recvbuf(:,:,:,:)
  real(dp),intent(in) :: xval(:,:,:,:)
 end subroutine xallgatherv_mpi_dp4d
end interface
!End of the generic interface of xallgatherv_mpi


!Generic interface of the routines xalltoall_mpi
interface xalltoall_mpi
 subroutine xalltoall_mpi_dp2d(xval, sendsize, recvbuf, recvsize, spaceComm, ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: recvsize
  integer ,intent(in) :: sendsize
  integer ,intent(in) :: spaceComm
  real(dp),intent(inout) :: recvbuf(:,:)
  real(dp),intent(in) :: xval(:,:)
 end subroutine xalltoall_mpi_dp2d
end interface
!End of the generic interface of xalltoall_mpi


!Generic interface of the routines xalltoallv_mpi
interface xalltoallv_mpi
 subroutine xalltoallv_mpi_dp2d(xval,sendcnts,sdispls,recvbuf,recvcnts,rdispls,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: spaceComm
  integer ,intent(in) :: rdispls(:)
  integer ,intent(in) :: recvcnts(:)
  integer ,intent(in) :: sdispls(:)
  integer ,intent(in) :: sendcnts(:)
  real(dp),intent(inout) :: recvbuf(:,:)
  real(dp),intent(in) :: xval(:,:)
 end subroutine xalltoallv_mpi_dp2d
 subroutine xalltoallv_mpi_int2d(xval,sendcnts,sdispls,recvbuf,recvcnts,rdispls,spaceComm,ier)
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: spaceComm
  integer ,intent(in) :: rdispls(:)
  integer,intent(inout) :: recvbuf(:,:)
  integer ,intent(in) :: recvcnts(:)
  integer ,intent(in) :: sdispls(:)
  integer ,intent(in) :: sendcnts(:)
  integer,intent(in) :: xval(:,:)
 end subroutine xalltoallv_mpi_int2d
 subroutine xalltoallv_mpi_dp1d(xval,sendcnts,sdispls,recvbuf,recvcnts,rdispls,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: rdispls
  integer ,intent(in) :: spaceComm
  integer ,intent(in) :: recvcnts(:)
  integer ,intent(in) :: sdispls(:)
  integer ,intent(in) :: sendcnts(:)
  real(dp),intent(inout) :: recvbuf(:)
  real(dp),intent(in) :: xval(:)
 end subroutine xalltoallv_mpi_dp1d
end interface
!End of the generic interface of xalltoallv_mpi


!Generic interface of the routines xcast_mpi
interface xcast_mpi
 subroutine xcast_mpi_intv(xval,master,spaceComm,ier)
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: master
  integer,intent(in) :: spaceComm
  integer,intent(inout) :: xval
 end subroutine xcast_mpi_intv
 subroutine xcast_mpi_int1d(xval,master,spaceComm,ier)
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: master
  integer,intent(in) :: spaceComm
  integer,intent(inout) :: xval(:)
 end subroutine xcast_mpi_int1d
 subroutine xcast_mpi_int2d(xval,master,spaceComm,ier)
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: master
  integer,intent(in) :: spaceComm
  integer,intent(inout) :: xval(:,:)
 end subroutine xcast_mpi_int2d
 subroutine xcast_mpi_int3d(xval,master,spaceComm,ier)
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: master
  integer,intent(in) :: spaceComm
  integer,intent(inout) :: xval(:,:,:)
 end subroutine xcast_mpi_int3d
 subroutine xcast_mpi_dpv(xval,master,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  real(dp),intent(inout) :: xval
 end subroutine xcast_mpi_dpv
 subroutine xcast_mpi_dp1d(xval,master,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  real(dp),intent(inout) :: xval(:)
 end subroutine xcast_mpi_dp1d
 subroutine xcast_mpi_dp2d(xval,master,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  real(dp),intent(inout) :: xval(:,:)
 end subroutine xcast_mpi_dp2d
 subroutine xcast_mpi_dp3d(xval,master,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  real(dp),intent(inout) :: xval(:,:,:)
 end subroutine xcast_mpi_dp3d
 subroutine xcast_mpi_dp4d(xval,master,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  real(dp),intent(inout) :: xval(:,:,:,:)
 end subroutine xcast_mpi_dp4d
 subroutine xcast_mpi_spv(xval,master,spaceComm,ier)
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: master
  integer,intent(in) :: spaceComm
  real,intent(inout) :: xval
 end subroutine xcast_mpi_spv
 subroutine xcast_mpi_sp1d(xval,master,spaceComm,ier)
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  real,intent(inout) :: xval(:)
 end subroutine xcast_mpi_sp1d
 subroutine xcast_mpi_sp2d(xval,master,spaceComm,ier)
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  real,intent(inout) :: xval(:,:)
 end subroutine xcast_mpi_sp2d
 subroutine xcast_mpi_sp3d(xval,master,spaceComm,ier)
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  real,intent(inout) :: xval(:,:,:)
 end subroutine xcast_mpi_sp3d
 subroutine xcast_mpi_sp4d(xval,master,spaceComm,ier)
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  real,intent(inout) :: xval(:,:,:,:)
 end subroutine xcast_mpi_sp4d
 subroutine xcast_mpi_cplxv(xval,master,spaceComm,ier)
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  complex,intent(inout) :: xval
 end subroutine xcast_mpi_cplxv
 subroutine xcast_mpi_cplx1d(xval,master,spaceComm,ier)
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  complex,intent(inout) :: xval(:)
 end subroutine xcast_mpi_cplx1d
 subroutine xcast_mpi_cplx2d(xval,master,spaceComm,ier)
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  complex,intent(inout) :: xval(:,:)
 end subroutine xcast_mpi_cplx2d
 subroutine xcast_mpi_cplx3d(xval,master,spaceComm,ier)
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  complex,intent(inout) :: xval(:,:,:)
 end subroutine xcast_mpi_cplx3d
 subroutine xcast_mpi_cplx4d(xval,master,spaceComm,ier)
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  complex,intent(inout) :: xval(:,:,:,:)
 end subroutine xcast_mpi_cplx4d
 subroutine xcast_mpi_dcv(xval,master,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  complex(dp),intent(inout) :: xval
 end subroutine xcast_mpi_dcv
 subroutine xcast_mpi_dc1d(xval,master,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  complex(dp),intent(inout) :: xval(:)
 end subroutine xcast_mpi_dc1d
 subroutine xcast_mpi_dc2d(xval,master,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  complex(dp),intent(inout) :: xval(:,:)
 end subroutine xcast_mpi_dc2d
 subroutine xcast_mpi_dc3d(xval,master,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  complex(dp),intent(inout) :: xval(:,:,:)
 end subroutine xcast_mpi_dc3d
 subroutine xcast_mpi_ch0d(xval,master,spaceComm,ier)
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: master
  integer,intent(in) :: spaceComm
  character(len=*),intent(inout) :: xval
 end subroutine xcast_mpi_ch0d
 subroutine xcast_mpi_ch1d(xval,master,spaceComm,ier)
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: master
  integer,intent(in) :: spaceComm
  character(len=*),intent(inout) :: xval(:)
 end subroutine xcast_mpi_ch1d
end interface
!End of the generic interface of xcast_mpi

interface
 subroutine xcomm_rank(spaceComm,rank,ierr)
  implicit none
  integer,intent(out) :: ierr
  integer,intent(out) :: rank
  integer,intent(in) :: spaceComm
 end subroutine xcomm_rank
end interface

interface
 subroutine xcomm_size(spaceComm,nprocs,ierr)
  implicit none
  integer,intent(out) :: ierr
  integer,intent(out) :: nprocs
  integer,intent(in) :: spaceComm
 end subroutine xcomm_size
end interface


!Generic interface of the routines xexch_mpi
interface xexch_mpi
 subroutine xexch_mpi_intn(vsend,n1,sender,vrecv,recever,spaceComm,ier)
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: n1
  integer,intent(in) :: recever
  integer,intent(in) :: sender
  integer,intent(in) :: spaceComm
  integer,intent(inout) :: vrecv(:)
  integer,intent(in) :: vsend(:)
 end subroutine xexch_mpi_intn
 subroutine xexch_mpi_int2d(vsend,nt,sender,vrecv,recever,spaceComm,ier)
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: nt
  integer,intent(in) :: recever
  integer,intent(in) :: sender
  integer,intent(in) :: spaceComm
  integer,intent(inout) :: vrecv(:,:)
  integer,intent(in) :: vsend(:,:)
 end subroutine xexch_mpi_int2d
 subroutine xexch_mpi_dpn(vsend,n1,sender,vrecv,recever,spaceComm,ier)
  use defs_basis
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: n1
  integer,intent(in) :: recever
  integer,intent(in) :: sender
  integer,intent(in) :: spaceComm
  real(dp),intent(inout) :: vrecv(:)
  real(dp),intent(in) :: vsend(:)
 end subroutine xexch_mpi_dpn
 subroutine xexch_mpi_dp2d(vsend,nt,sender,vrecv,recever,spaceComm,ier)
  use defs_basis
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: nt
  integer,intent(in) :: recever
  integer,intent(in) :: sender
  integer,intent(in) :: spaceComm
  real(dp),intent(inout) :: vrecv(:,:)
  real(dp),intent(in) :: vsend(:,:)
 end subroutine xexch_mpi_dp2d
 subroutine xexch_mpi_dp3d(vsend,nt,sender,vrecv,recever,spaceComm,ier)
  use defs_basis
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: nt
  integer,intent(in) :: recever
  integer,intent(in) :: sender
  integer,intent(in) :: spaceComm
  real(dp),intent(inout) :: vrecv(:,:,:)
  real(dp),intent(in) :: vsend(:,:,:)
 end subroutine xexch_mpi_dp3d
end interface
!End of the generic interface of xexch_mpi


!Generic interface of the routines xmax_mpi
interface xmax_mpi
 subroutine xmax_mpi_intv(xval,xmax,spaceComm,ier)
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: spaceComm
  integer ,intent(inout) :: xmax
  integer ,intent(inout) :: xval
 end subroutine xmax_mpi_intv
 subroutine xmax_mpi_dpv(xval,xmax,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: spaceComm
  real(dp),intent(inout) :: xmax
  real(dp),intent(inout) :: xval
 end subroutine xmax_mpi_dpv
end interface
!End of the generic interface of xmax_mpi


!Generic interface of the routines xmin_mpi
interface xmin_mpi
 subroutine xmin_mpi_intv(xval,xmin,spaceComm,ier)
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: spaceComm
  integer ,intent(inout) :: xmin
  integer ,intent(inout) :: xval
 end subroutine xmin_mpi_intv
 subroutine xmin_mpi_dpv(xval,xmin,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: spaceComm
  real(dp),intent(inout) :: xmin
  real(dp),intent(inout) :: xval
 end subroutine xmin_mpi_dpv
end interface
!End of the generic interface of xmin_mpi

interface
 subroutine xmpi_me(me)
  implicit none
  integer,intent(out) :: me
 end subroutine xmpi_me
end interface

interface
 subroutine xmpi_nproc(nproc,ierr)
  implicit none
  integer,intent(out) :: ierr
  integer,intent(out) :: nproc
 end subroutine xmpi_nproc
end interface


!Generic interface of the routines xsum_master
interface xsum_master
 subroutine xsum_master_dp1d(xval,master,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  real(dp),intent(inout) :: xval(:)
 end subroutine xsum_master_dp1d
 subroutine xsum_master_dp2d(xval,master,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  real(dp),intent(inout) :: xval(:,:)
 end subroutine xsum_master_dp2d
 subroutine xsum_master_dp3d(xval,master,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  real(dp),intent(inout) :: xval(:,:,:)
 end subroutine xsum_master_dp3d
 subroutine xsum_master_dp4d(xval,master,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  real(dp),intent(inout) :: xval(:,:,:,:)
 end subroutine xsum_master_dp4d
 subroutine xsum_master_dp5d(xval,master,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  real(dp),intent(inout) :: xval(:,:,:,:,:)
 end subroutine xsum_master_dp5d
 subroutine xsum_master_dp6d(xval,master,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  real(dp),intent(inout) :: xval(:,:,:,:,:,:)
 end subroutine xsum_master_dp6d
 subroutine xsum_master_dp7d(xval,master,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  real(dp),intent(inout) :: xval(:,:,:,:,:,:,:)
 end subroutine xsum_master_dp7d
 subroutine xsum_master_int4d(xval,master,spaceComm,ier)
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  integer ,intent(inout) :: xval(:,:,:,:)
 end subroutine xsum_master_int4d
 subroutine xsum_master_c2cplx(xval,master,spaceComm,ier)
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  complex ,intent(inout) :: xval(:,:)
 end subroutine xsum_master_c2cplx
 subroutine xsum_master_c3cplx(xval,master,spaceComm,ier)
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  complex ,intent(inout) :: xval(:,:,:)
 end subroutine xsum_master_c3cplx
 subroutine xsum_master_c4cplx(xval,master,spaceComm,ier)
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  complex ,intent(inout) :: xval(:,:,:,:)
 end subroutine xsum_master_c4cplx
 subroutine xsum_master_c2dpc(xval,master,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  complex(dpc) ,intent(inout) :: xval(:,:)
 end subroutine xsum_master_c2dpc
 subroutine xsum_master_c3dpc(xval,master,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  complex(dpc) ,intent(inout) :: xval(:,:,:)
 end subroutine xsum_master_c3dpc
 subroutine xsum_master_c4dpc(xval,master,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: master
  integer ,intent(in) :: spaceComm
  complex(dpc) ,intent(inout) :: xval(:,:,:,:)
 end subroutine xsum_master_c4dpc
end interface
!End of the generic interface of xsum_master


!Generic interface of the routines xsum_mpi
interface xsum_mpi
 subroutine xsum_mpi_int(xval,spaceComm,ier)
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: spaceComm
  integer,intent(inout) :: xval(:)
 end subroutine xsum_mpi_int
 subroutine xsum_mpi_intv(xval,spaceComm,ier)
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: spaceComm
  integer,intent(inout) :: xval
 end subroutine xsum_mpi_intv
 subroutine xsum_mpi_intv2(xval,xsum,spaceComm,ier)
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: spaceComm
  integer,intent(inout) :: xsum
  integer,intent(inout) :: xval
 end subroutine xsum_mpi_intv2
 subroutine xsum_mpi_intn(xval,n1,spaceComm,ier)
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: n1
  integer,intent(in) :: spaceComm
  integer,intent(inout) :: xval(:)
 end subroutine xsum_mpi_intn
 subroutine xsum_mpi_int2t(xval,xsum,n1,spaceComm,ier)
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: n1
  integer ,intent(in) :: spaceComm
  integer ,intent(inout) :: xsum(:)
  integer ,intent(inout) :: xval(:)
 end subroutine xsum_mpi_int2t
 subroutine xsum_mpi_int2d(xval,spaceComm,ier)
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: spaceComm
  integer,intent(inout) :: xval(:,:)
 end subroutine xsum_mpi_int2d
 subroutine xsum_mpi_int3d(xval,spaceComm,ier)
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: spaceComm
  integer,intent(inout) :: xval(:,:,:)
 end subroutine xsum_mpi_int3d
 subroutine xsum_mpi_int4d(xval,spaceComm,ier)
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: spaceComm
  integer,intent(inout) :: xval(:,:,:,:)
 end subroutine xsum_mpi_int4d
 subroutine xsum_mpi_dp(xval,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: spaceComm
  real(dp),intent(inout) :: xval(:)
 end subroutine xsum_mpi_dp
 subroutine xsum_mpi_dpvt(xval,xsum,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: spaceComm
  real(dp),intent(out) :: xsum
  real(dp),intent(in) :: xval
 end subroutine xsum_mpi_dpvt
 subroutine xsum_mpi_dpv(xval,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: spaceComm
  real(dp),intent(inout) :: xval
 end subroutine xsum_mpi_dpv
 subroutine xsum_mpi_dpn(xval,n1,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: n1
  integer ,intent(in) :: spaceComm
  real(dp),intent(inout) :: xval(:)
 end subroutine xsum_mpi_dpn
 subroutine xsum_mpi_dp2d(xval,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: spaceComm
  real(dp),intent(inout) :: xval(:,:)
 end subroutine xsum_mpi_dp2d
 subroutine xsum_mpi_dp3d(xval,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: spaceComm
  real(dp),intent(inout) :: xval(:,:,:)
 end subroutine xsum_mpi_dp3d
 subroutine xsum_mpi_dp4d(xval,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: spaceComm
  real(dp),intent(inout) :: xval(:,:,:,:)
 end subroutine xsum_mpi_dp4d
 subroutine xsum_mpi_dp5d(xval,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: spaceComm
  real(dp),intent(inout) :: xval(:,:,:,:,:)
 end subroutine xsum_mpi_dp5d
 subroutine xsum_mpi_dp6d(xval,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: spaceComm
  real(dp),intent(inout) :: xval(:,:,:,:,:,:)
 end subroutine xsum_mpi_dp6d
 subroutine xsum_mpi_dp2t(xval,xsum,n1,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: n1
  integer ,intent(in) :: spaceComm
  real(dp),intent(inout) :: xsum(:)
  real(dp),intent(inout) :: xval(:)
 end subroutine xsum_mpi_dp2t
 subroutine xsum_mpi_dp3d2t(xval,xsum,n1,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: n1
  integer ,intent(in) :: spaceComm
  real(dp),intent(inout) :: xsum(:,:,:)
  real(dp),intent(inout) :: xval(:,:,:)
 end subroutine xsum_mpi_dp3d2t
 subroutine xsum_mpi_dp4d2t(xval,xsum,n1,spaceComm,ier)
  use defs_basis
  implicit none
  integer ,intent(out) :: ier
  integer ,intent(in) :: n1
  integer ,intent(in) :: spaceComm
  real(dp),intent(inout) :: xsum(:,:,:,:)
  real(dp),intent(inout) :: xval(:,:,:,:)
 end subroutine xsum_mpi_dp4d2t
 subroutine xsum_mpi_c1dc(xval,spaceComm,ier)
  use defs_basis
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: spaceComm
  complex(dpc),intent(inout) :: xval(:)
 end subroutine xsum_mpi_c1dc
 subroutine xsum_mpi_c2dc(xval,spaceComm,ier)
  use defs_basis
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: spaceComm
  complex(dpc),intent(inout) :: xval(:,:)
 end subroutine xsum_mpi_c2dc
 subroutine xsum_mpi_c3dc(xval,spaceComm,ier)
  use defs_basis
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: spaceComm
  complex(dpc),intent(inout) :: xval(:,:,:)
 end subroutine xsum_mpi_c3dc
 subroutine xsum_mpi_c4dc(xval,spaceComm,ier)
  use defs_basis
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: spaceComm
  complex(dpc),intent(inout) :: xval(:,:,:,:)
 end subroutine xsum_mpi_c4dc
 subroutine xsum_mpi_c1cplx(xval,spaceComm,ier)
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: spaceComm
  complex,intent(inout) :: xval(:)
 end subroutine xsum_mpi_c1cplx
 subroutine xsum_mpi_c2cplx(xval,spaceComm,ier)
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: spaceComm
  complex,intent(inout) :: xval(:,:)
 end subroutine xsum_mpi_c2cplx
 subroutine xsum_mpi_c3cplx(xval,spaceComm,ier)
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: spaceComm
  complex,intent(inout) :: xval(:,:,:)
 end subroutine xsum_mpi_c3cplx
 subroutine xsum_mpi_c4cplx(xval,spaceComm,ier)
  implicit none
  integer,intent(out) :: ier
  integer,intent(in) :: spaceComm
  complex,intent(inout) :: xval(:,:,:,:)
 end subroutine xsum_mpi_c4cplx
end interface
!End of the generic interface of xsum_mpi

end module interfaces_12_hide_mpi
!!***
