!{\src2tex{textfont=tt}}
!!****f* ABINIT/xcomm_rank
!! NAME
!! xcomm_rank
!!
!! FUNCTION
!! Hide MPI_COMM_RANK from MPI library
!!
!! COPYRIGHT
!! Copyright (C) 2003-2009 ABINIT group (MB)
!! This file is distributed under the terms of the
!! GNU General Public License, see ~abinit/COPYING
!! or http://www.gnu.org/copyleft/gpl.txt .
!!
!! NOTES
!!
!! SOURCE
subroutine xcomm_rank(spaceComm,rank,ierr)

#if defined MPI && defined MPI2
 use mpi
#endif

 implicit none

#if defined MPI && defined MPI1
 include 'mpif.h'
#endif

!Arguments-------------------------
 integer,intent(in) :: spaceComm
 integer,intent(out) :: rank,ierr

!Local variables-------------------

! *************************************************************************
#if defined MPI
 call MPI_COMM_RANK(spaceComm,rank,ierr)
#else
 ierr=0 ; rank=0
#endif

end subroutine xcomm_rank
!!***
