!{\src2tex{textfont=tt}}
!!****f* ABINIT/xcomm_size
!! NAME
!! xcomm_size
!!
!! FUNCTION
!! Hide MPI_COMM_SIZE from MPI library
!!
!! COPYRIGHT
!! Copyright (C) 2003-2009 ABINIT group (MB,XG)
!! This file is distributed under the terms of the
!! GNU General Public License, see ~abinit/COPYING
!! or http://www.gnu.org/copyleft/gpl.txt .
!!
!! NOTES
!!
!! SOURCE
subroutine xcomm_size(spaceComm,nprocs,ierr)

#if defined MPI && defined MPI2
 use mpi
#endif

 implicit none

#if defined MPI && defined MPI1
 include 'mpif.h'
#endif

!Arguments-------------------------
 integer,intent(in) :: spaceComm
 integer,intent(out) :: nprocs,ierr

!Local variables-------------------

! *************************************************************************

#if defined MPI
 call MPI_COMM_SIZE(spaceComm,nprocs,ierr)
#else
 ierr=0 ; nprocs=1
#endif

end subroutine xcomm_size
!!***
