!{\src2tex{textfont=tt}}
!!****f* ABINIT/xmpi_me
!! NAME
!! xmpi_me
!!
!! FUNCTION
!! Hide MPI_COMM_RANK for MPI_COMM_WORLD from MPI library
!!
!! COPYRIGHT
!! Copyright (C) 2003-2009 ABINIT group (MB,XG)
!! This file is distributed under the terms of the
!! GNU General Public License, see ~abinit/COPYING
!! or http://www.gnu.org/copyleft/gpl.txt .
!!
!! NOTES
!!
!! SOURCE
subroutine xmpi_me(me)


#if defined MPI && defined MPI2
 use mpi
#endif

 implicit none

#if defined MPI && defined MPI1
 include 'mpif.h'
#endif

!Arguments-------------------------
 integer,intent(out) :: me

!Local variables-------------------

#if defined MPI
           integer :: ierr
#endif

! *************************************************************************

 me=0
#if defined MPI
        call MPI_COMM_RANK(MPI_COMM_WORLD,me,ierr)
#endif
end subroutine xmpi_me
!!***
