!{\src2tex{textfont=tt}}
!!****f* ABINIT/xmpi_nproc
!! NAME
!! xmpi_nproc
!!
!! FUNCTION
!! Hide MPI_COMM_SIZE of MPI_COMM_WORLD from MPI library
!!
!! COPYRIGHT
!! Copyright (C) 2003-2009 ABINIT group (MB)
!! This file is distributed under the terms of the
!! GNU General Public License, see ~abinit/COPYING
!! or http://www.gnu.org/copyleft/gpl.txt .
!!
!! NOTES
!!
!! SOURCE
subroutine xmpi_nproc(nproc,ierr)


#if defined MPI && defined MPI2
 use mpi
#endif

 implicit none

#if defined MPI && defined MPI1
 include 'mpif.h'
#endif

!Arguments-------------------------
 integer,intent(out) :: nproc,ierr

!Local variables-------------------

! *************************************************************************
 ierr=0
 nproc = 1
#if defined MPI
        call MPI_COMM_SIZE(MPI_COMM_WORLD,nproc,ierr)
#endif
end subroutine xmpi_nproc
!!***
